/*
 * MSXML2 uuids
 *
 * Copyright 2006 Huw Davies
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
 */

/*
 * We can't use the autogenerated _i.c file from msxml2.idl as that
 * will contain some of the (version 2) uuids defined in libuuid.
 * Therefore we roll our own.
 */

#include <stdarg.h>

#include "windef.h"
#include "winbase.h"
#include "winuser.h"
#include "ole2.h"

/*
 * First include the version 2 headers so that we don't redefine their
 * uuids - they're already in libuuid
 */
#include "msxml.h"

/* Now we can initialize the rest of the uuids */
#include "initguid.h"
#include "msxml2.h"

/*
 * Note that because of a #define in msxml2.h, we end up initializing
 * CLSID_DOMDocument2 to be the v.3 version independent DOMDocument
 * class {f6d90f11-9c73-11d3-b32e-00c04f990bb4}.  The other version
 * independent CLSIDs all have slightly different names:
 *
 * v.2.x                              v.3.0
 *
 * DOMFreeThreadedDocument            FreeThreadedDOMDocument
 * XMLHTTPRequest                     XMLHTTP
 * XMLDSOControl                      DSOControl
 *
 */
